/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
/* 生词本模块：
*   定义 添加生词本方法 addScb , 成功添加回调方法 onScbSuccess
*/
/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
var scbObjs = [], scbFrom = "";
/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 *     "failedCallback":"onScbFailed"            //失败回调函数
 * }
 */
function addScb(jsonData, obj, from){
    jsonData = parseJson(jsonData);
    scbObjs[jsonData.uwid] = obj;
    if(typeof(from)!="undefined") scbFrom = from;
    try{ dictcn.addScb(JSON.stringify({'uwid':jsonData.uwid,'successCallback':'onScbSuccess','failedCallback':'onScbFailed'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb":"0|1"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || "0";
    try{
        var $wordhead = $('.wordhead');

        var img_name = "btn-add.png";
        if(in_scb == "1"){
            img_name = "btn-added.png";
        }

        if(scbFrom=="phrase"){
           scbObjs[uwid].src = _resource_+'/images/' + img_name;
        } else if($wordhead.length>1){
            $wordhead.children('.scbadd').children('img').attr('src',_resource_+'/images/' + img_name);
        } else {
            scbObjs[uwid].src = _resource_+'/images/' + img_name;
        }
    }catch(e){}
}


///////////////////////////播放声音/////////////////////////////////////////////////////////////////////
/* 播放声音模块：
*   定义 声音播放函数 playSound, 播放声音图标动画方法 onStartPlaySound， 停止播放动画函数 onEndPlaySound
*/
///////////////////////////播放声音/////////////////////////////////////////////////////////////////////
var globAnima = null, globCurObj = null,defSoundSrc = '';
/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "lang":"b",                                //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "aw":"",                                   //发音类型
 *     "symbol":"",                               //音标发音
 *     "v":"2",                                   //版本号
 *     "url":"url",                               //mp3地址，支持url发音
 *     "startCallback":"onStartPlaySound",         //开始播放声音动画js回调
 *     "endCallback":"onEndPlaySound"              //停止播放声音动画js回调
 * }
 */
function playSound(jsonData,obj){
    jsonData = parseJson(jsonData);
    onEndPlaySound();
    globCurObj = $(obj);
    defSoundSrc = $(obj).attr('src');
    var symbol = jsonData.symbol || "";
    var pinyin = jsonData.pinyin || "";
    var v = jsonData.v || "";
    var aw = jsonData.aw || "";
    var uwid = jsonData.uwid || "";
    var lang = jsonData.lang || "";
    var key = jsonData.key || "";
    var scode = jsonData.scode || "";
    try{ dictcn.playSound(JSON.stringify({'uwid':uwid,'lang':lang,'key':key,'scode':scode,'symbol':symbol,'pinyin':pinyin,'v':v,'aw':aw,'startCallback':'onStartPlaySound','endCallback':'onEndPlaySound'})); }catch(e){}
}

/* 开始播放声音动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onStartPlaySound(jsonData){
    try{
        var i = 1;
        globAnima = setInterval(function(){
            if(i>3) i=1;
            globCurObj.attr('src',_resource_+'/images/btn-voice-'+i+'.png');
            i++;
        },200);
    }catch(e){}
}

/* 停止播放声音动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onEndPlaySound(jsonData){
    try{
        clearInterval(globAnima);
        globCurObj.attr('src', defSoundSrc);
    }catch(e){}
}



////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字或词组模块：
*   定义 查字方法 searchText， 查词方法 ajaxSearch， 查词成功函数 onAjaxSuccess，查词失败函数 onAjaxFailed
*/
////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的字
 * }
 */
function searchText(jsonData){
    jsonData = parseJson(jsonData);
    var text = jsonData.text || "";
    try{ dictcn.searchText(JSON.stringify({'text':text})); }catch(e){}
}

/* 查词组
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的词组
 *     tplName:"",                              //模板名称
 *     successCallback:"onAjaxSuccess",
 *     failedCallback:"onAjaxFailed"
 * }
 */
var globPhraseObj = null;
function ajaxSearch(jsonData,obj,display){
    jsonData = parseJson(jsonData);
    var text = jsonData.text || "";
    var tplName = jsonData.tplName || "";
    var from = jsonData.from || "";
    if(typeof(display)=="undefined") display = "none";
    if($(obj).next()[0].style.display==display){
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-up.png');
        if($(obj).next().children('.ajax-search').length){ $(obj).next().show();}
        else{
	        try{
	            $(obj).next().html('<div class="phrase-loadding">Loading...</div>');
	            //if(globPhraseObj && globPhraseObj!=obj) $(globPhraseObj).next().html('<div class="phrase-loadding">Failed to load. Please try again later!</div>');
	            $(obj).next().show();
	            globPhraseObj = obj;
	            dictcn.ajaxSearch(JSON.stringify({'text':text,'tplName':tplName,'from':from,'successCallback':'onAjaxSuccess','failedCallback':'onAjaxFailed'}));
	        }catch(e){}
	    }
    } else {
        $(obj).next().hide();
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-down.png');
    }

     if(swiperScroll){
        swiperScroll = swiperScrolls[swiperPages.activeIndex];
        if($(swiperScroll.wrapper).find('.page-inner').height() > $(window).height() + 66 && $(swiperScroll.wrapper).find('.footer').height() > 66){
            $(swiperScroll.wrapper).find('.footer').css({
                    paddingBottom: 65
                })
        }else if($(swiperScroll.wrapper).find('.page-inner').height() < $(window).height() - $('.swiper-nav .nav-content').height() ){
            $(swiperScroll.wrapper).find('.footer').css({
                    paddingBottom: ($(window).height() - $(swiperScroll.wrapper).find('.page-inner').height())
                })
        }
        swiperScroll.resizeFix(true);
    }else{
        swiperMain.resizeFix(true);
    }
}
/* 查词成功
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     html:""                                 //返回的html片段
 * }
 */
function onAjaxSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{
        var $uwidEle = $('#uwid'+uwid);
        $uwidEle.next().html(jsonData.html);
        
        if(typeof onAjaxResize != 'undefined'){
        	onAjaxResize(uwid);
        }
        globPhraseObj = null;
        if(auto_uwid) {
            if(parseInt(auto_uwid)!=0){
            	swipeToView($uwidEle[0]);
            }
            auto_uwid='';
            if($uwidEle.next()[0].style.display=="none") $uwidEle.next().show();
            $uwidEle.children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-up.png');
         }
    }catch(e){}
    if(typeof swiperScroll != 'undefined' && swiperScroll){
    	swiperScroll.resizeFix(true);
    }else if(typeof swiperMain != 'undefined' && swiperMain) {
    	swiperMain.resizeFix(true);
    }
}

function swipeToView(obj){
	if(typeof swiperMain != 'undefined' && swiperMain) {
		var swipe = swiperMain;
		var pos = -swipe.h.getOffset(obj).top + 5;
		if(typeof swiperScroll != 'undefined' && swiperScroll){
	    	swipe = swiperScroll;
	    	pos += swipe.h.getOffset(swipe.container).top;
	    	swiperMain.setWrapperTransDelay(0);
	    	swiperMain.setWrapperTransition(0);
	    	swiperMain.setWrapperTranslate(-swipe.getHeaderHeight());
	    }
    	swipe.setWrapperTransDelay(0);
	    swipe.setWrapperTransition(0);
		swipe.setWrapperTranslate(pos);
    }
    
}
/* 查词失败
 * 参数格式json:
 * jsonData = {
 *     uwid:"",                                 //uwid
 *     tip:""                                  //提示信息
 * }
 */
function onAjaxFailed(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var tip = jsonData.tip || "加载失败，请稍后重试！";
    try{
     $('#uwid'+uwid).next().html("<div class='phrase-loadding'>"+tip+"</div>");
    }catch(e){}
    if(typeof swiperScroll != 'undefined' && swiperScroll){
    	swiperScroll.resizeFix(true);
    }else if(typeof swiperMain != 'undefined' && swiperMain) {
    	swiperMain.resizeFix(true);
    }
}



///////////////////播放笔顺动画///////////////////////////////////////////////////////////////////////////////////////
/* 播放笔顺动画模块：
*   定义 弹出动画窗口方法 popupPlayStroke 播放笔顺动画方法 playStroke，开始播放笔顺动画方法 onStartPlayStroke，加载图
*   片方法 nativeLoadImage， 图片加载成功方法 onImageLoadSuccess， 图片加载失败方法 onImageLoadFailed
*/
///////////////////播放笔顺动画///////////////////////////////////////////////////////////////////////////////////////
/* 弹出笔顺动画窗口
 * 参数格式json:
 * jsonData = {
 *     key:"",                                 //要查询的词组
 *     word："",                               //要播放的词
 *     pinyins："",                            //
 *     cvec："",                               //
 *     sorder："",                             //
 *     tplName:""                              //模板名称
 * }
 */
function popupPlayStroke(jsonData){
     jsonData = parseJson(jsonData);
     var word = jsonData.word || "";
     var pinyins = jsonData.pinyins || "";
     var cvec = jsonData.cvec || "";
     var sorder = jsonData.sorder || "";
     var tplname = "stroke.chtml";
     if(typeof(jsonData.tplName)!="undefined") tplname = jsonData.tplName;
     try{ dictcn.popupPlayStroke(JSON.stringify({'word':word, 'pinyins':pinyins,'cvec':cvec,'sorder':sorder})); }catch(e){}

}

/* 播放笔顺动画
 * 参数格式json:
 * jsonData = {
 *     key:"",                                 //要查询的词组
 *     text:"",                                //要查询的词组
 *     startCallback:"onStartPlayStroke",      //成功回调函数
 *     endCallback:""
 * }
 */
var globStrokeObj = null;
function playStroke(jsonData,obj){
    jsonData = parseJson(jsonData);
    var text = jsonData.text || "";
    globStrokeObj = obj;
    try{ dictcn.playStroke(JSON.stringify({'key':text,'startCallback':'onStartPlayStroke','endCallback':''})); }catch(e){}
}
/* 开始播放笔顺动画
 * 参数格式json:
 * jsonData = {
 *     sorder:"",                                 //
 *     cvec:""，                                  //
 *     pinyins:"",                                //
 *     url:"",                                    //
 *     path:"",                                   //
 *     image_id:""                                //
 * }
 */
function onStartPlayStroke(jsonData){
    jsonData = parseJson(jsonData);
    try{show_stroke_order(jsonData, globStrokeObj);}catch(e){}
    globStrokeObj=null;
}

function nativeLoadImage(jsonData, obj){
    obj.onload = null;
    jsonData = parseJson(jsonData);
    var img_id = "image_id_"+new Date().getTime()+""+Math.floor(Math.random()*10000);
    $(obj).attr("id", img_id);
    try{ dictcn.nativeLoadImage(JSON.stringify({'url':jsonData.url,'image_id':img_id})); }catch(e){}
}

function onImageLoadSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", jsonData.path); }catch(e){}
      
}
function onImageLoadFailed(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", _resource_+'/images/default.png'); }catch(e){}
}



//////////////////////////// usefull functions //////////////////////////////////////////////
/* usefull functions模块：
*   定义 json解析方法 parseJson, 判断是否json对象方法 isJson， 屏幕取词方法 popupDict
*/
//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}

/* 屏幕取词
 * 参数格式json:
 * jsonData = {
 *     "prevText":"",                                //text before offset
 *     "nextText":"",                                //text after offset
 *     "clientX":"",                                 //current position X
 *     "clientY":"",                                 //current position Y
 *     "query":"",                                   //query key in query action
 *     "action":"highLight|query",             //actions
 * }
 * result: popupDictCallback(jsonData) the same format with modified prevText and nextText
 */
function popupDict(jsonData){
	var jsonStr = JSON.stringify(jsonData);
	//document.title = jsonStr;
	try{
		dictcn.popupDict(jsonStr);
	}catch(e){
		
	    /*  callback result for testing
	    	remove the next line in production
	    */
		popupDictCallback(jsonStr);		
	}
}


/* 屏幕取词回调函数
 * 参数格式json:
 * jsonData = {
 *     "prevText":"",                                 //text after split
 *     "nextText":"",                                 //text after split
 *     "action":"highLight|closeDict|startCapture|stopCapture",         //start|stop captureMode; close popupDict
 * }
 */
function popupDictCallback(jsonData){
	var jsonObj = parseJson(jsonData);
	if(typeof popupDictCall == 'function') popupDictCall(jsonObj);
}
